#ifndef RAQUETTE_H_INCLUDED
#define RAQUETTE_H_INCLUDED

#include "main.h"

#define VITESSE 1.5
#define RAYON_FENETRE (COTE/2)
#define RAYON_TERRAIN (RAYON_FENETRE-COTE/36)
#define RAYON_RQT (COTE/12)
#define ANGLE_ECART_RQT (asin((float)RAYON_RQT/RAYON_TERRAIN)*180/M_PI+1)

class Raquette
{
public:
    Raquette(int identifiant, int nbJoueursTotal, Uint32 couleur);
    ~Raquette();

    void afficher(SDL_Surface* screen);
    void deplacer(bool droite);
    Vecteur getAngleActuel();

private:
    //Attributs vectoriels
    Vecteur m_angleActuel;
    Vecteur m_angleOrigine;
    Vecteur m_centre;
    Vecteur m_position;

    //Autres
    float const m_angleEcartMax;
    unsigned short m_identifiant;

    //Attributs SDL
    SDL_Surface *m_pixel;
};

#endif // RAQUETTE_H_INCLUDED
