#ifndef POINT_H_INCLUDED
#define POINT_H_INCLUDED

///Modifié le: 10/06/2013
///Objet: débuggage, mise en fonction

#include <iostream>
#include <SDL/SDL.h>
#include <cmath>

/*
===La classe Point===
    +Définition:
        La classe Point permet de créer un  point.
    +Fonctions:
        -Constructeur standard:
            Ne prend que le rayon et la couleur en paramètre, mesure en nb de pixels.
        -Constructeur amélioré:
            Permet de définir en plus du rayon et de la couleur
            le coefficient de transparence. (0=visible à 255=invsible)
        -getRayon:
            Permet d'obtenir le rayon.

*/

class Point
{
    public:
    Point(int rayon,Uint32 couleur);
    Point(int rayon,Uint32 couleur,int transparence);
    ~Point();
    int getRayon();
    void afficherPoint(SDL_Surface *screen,int const x, int const y);

    private:
    //Attributs standards:
    int const m_rayon;

    //Attributs SDL:
    SDL_Surface *m_pixel;
};
#endif // POINT_H_INCLUDED
